Automate installation of DXVK, D9VK + Wine/Wine Staging & update GPU drivers + PlayonLinux wineprefixes (Debian/Ubuntu/Mint/Arch Linux/Manjaro)
You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

420 lines
12 KiB

5 years ago
5 years ago
2 years ago
2 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
5 years ago
  1. #!/bin/env bash
  2. # DXVK/Wine-Staging scripts dispatcher for various Linux distributions
  3. # Copyright (C) 2019 Pekka Helenius
  4. #
  5. # This program is free software: you can redistribute it and/or modify
  6. # it under the terms of the GNU General Public License as published by
  7. # the Free Software Foundation, either version 3 of the License, or
  8. # (at your option) any later version.
  9. #
  10. # This program is distributed in the hope that it will be useful,
  11. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  12. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  13. # GNU General Public License for more details.
  14. #
  15. # You should have received a copy of the GNU General Public License
  16. # along with this program. If not, see <https://www.gnu.org/licenses/>.
  17. ##############################################################################
  18. source options.conf
  19. ###########################################################
  20. # Check if we're using bash or sh to run the script. If bash, OK.
  21. # If another one, ask user to run the script with bash.
  22. BASH_CHECK=$(ps | grep `echo $$` | awk '{ print $4 }')
  23. if [ $BASH_CHECK != "bash" ]; then
  24. echo "
  25. Please run this script using bash (/usr/bin/bash).
  26. "
  27. exit 1
  28. fi
  29. ###########################################################
  30. # Just a title & author for this script, used in initialization and help page
  31. SCRIPT_TITLE="\e[1mWine/Wine Staging & DXVK package builder & auto-installer\e[0m"
  32. SCRIPT_AUTHOR="Pekka Helenius (~Fincer), 2019"
  33. ###########################################################
  34. # Allow interruption of the script at any time (Ctrl + C)
  35. trap "exit" INT
  36. ###########################################################
  37. COMMANDS=(
  38. curl
  39. date
  40. df
  41. find
  42. git
  43. grep
  44. groups
  45. nproc
  46. patch
  47. readlink
  48. sudo
  49. tar
  50. uname
  51. wc
  52. wget
  53. )
  54. SUDO_GROUPS=(
  55. sudo
  56. wheel
  57. )
  58. function checkCommands() {
  59. local COMMANDS_NOTFOUND
  60. local a
  61. if [[ $(which --help 2>/dev/null) ]] && [[ $(echo --help 2>/dev/null) ]]; then
  62. a=0
  63. for command in ${@}; do
  64. if [[ ! $(which $command 2>/dev/null) ]]; then
  65. COMMANDS_NOTFOUND[$a]=${command}
  66. let a++
  67. fi
  68. done
  69. if [[ -n $COMMANDS_NOTFOUND ]]; then
  70. echo -e "\nError! The following commands could not be found: ${COMMANDS_NOTFOUND[*]}\nAborting\n"
  71. exit 1
  72. fi
  73. else
  74. exit 1
  75. fi
  76. }
  77. checkCommands "${COMMANDS[*]}"
  78. ###########################################################
  79. # http://wiki.bash-hackers.org/snipplets/print_horizontal_line#a_line_across_the_entire_width_of_the_terminal
  80. function INFO_SEP() { printf '%*s\n' "${COLUMNS:-$(tput cols)}" '' | tr ' ' - ; }
  81. ###########################################################
  82. if [[ $(uname -a | grep -c x86_64) -eq 0 ]]; then
  83. echo "This script supports 64-bit architectures only."
  84. exit 1
  85. fi
  86. if [[ $(groups | grep -cE $(echo ${SUDO_GROUPS[*]} | sed 's/ /|/g')) -eq 0 ]]; then
  87. echo "You must belong to a sudo group (checked groups: ${SUDO_GROUPS[*]})."
  88. exit 1
  89. fi
  90. unset sudogrp
  91. if [[ $UID -eq 0 ]]; then
  92. echo "Run as a regular user."
  93. exit 1
  94. fi
  95. ###########################################################
  96. # User-passed arguments for the script
  97. # We check the values of this array
  98. # and pass them to the subscripts if supported
  99. i=0
  100. for arg in ${@}; do
  101. case ${arg} in
  102. --no-staging)
  103. # Do not build Wine staging version, just Wine
  104. ;;
  105. --no-install)
  106. # Just build, do not install DXVK or Wine-Staging
  107. # Note that some version of Wine is required for DXVK compilation, though!
  108. ;;
  109. --no-wine)
  110. # Skip Wine build & installation process all together
  111. NO_WINE=
  112. ;;
  113. --no-dxvk)
  114. # Skip DXVK build & installation process all together
  115. NO_DXVK=
  116. ;;
  117. --no-vkd3d)
  118. # Skip VKD3D Proton build & installation process all together
  119. NO_VKD3D=
  120. ;;
  121. --no-nvapi)
  122. # Skip DXVK NVAPI build & installation process all together
  123. NO_NVAPI=
  124. ;;
  125. --no-pol)
  126. # Skip PlayOnLinux Wine prefixes update process
  127. ;;
  128. *)
  129. echo -e "\n\
  130. \
  131. ${SCRIPT_TITLE} by ${SCRIPT_AUTHOR}\n\n\
  132. Usage:\n\nbash updatewine.sh\n\nArguments:\n\n\
  133. --no-install\tDo not install Wine or DXVK. Just compile them. Wine, meson & glslang must be installed for DXVK compilation.\n\
  134. --no-dxvk\tDo not compile or install DXVK\n\
  135. --no-vkd3d\tDo not compile or install VKD3D Proton\n\
  136. --no-nvapi\tDo not compile or install DXVK NVAPI\n\
  137. --no-pol\tDo not update PlayOnLinux Wine prefixes\n\n\
  138. --no-staging\tCompile Wine instead of Wine Staging\n\
  139. --no-wine\tDo not compile or install Wine/Wine Staging\n\n\
  140. Compiled packages are installed by default, unless '--no-install' argument is given.\n\
  141. If '--no-install' argument is given, the script doesn't check or update your PlayOnLinux Wine prefixes.\n"
  142. exit 0
  143. ;;
  144. esac
  145. args[$i]="${arg}"
  146. let i++
  147. done
  148. ###########################################################
  149. # Date timestamp and random number identifier for compiled
  150. # DXVK & Wine Staging builds
  151. # This variable is known as 'datedir' in other script files
  152. datesuffix=$(echo $(date '+%Y-%m-%d-%H%M%S'))
  153. ###########################################################
  154. # Add git commit hash overrides to argument list
  155. # Pass them to subscripts, as well.
  156. githash_overrides=(
  157. "${git_commithash_dxvknvapi}" # 0
  158. "${git_commithash_vkd3dproton}" # 1
  159. "${git_commithash_dxvk}" # 2
  160. "${git_commithash_glslang}" # 3
  161. "${git_commithash_meson}" # 4
  162. "${git_commithash_wine}" # 5
  163. )
  164. # Add git branches to argument list
  165. # Pass them to subscripts, as well.
  166. gitbranch_overrides=(
  167. "${git_branch_dxvknvapi}" # 6
  168. "${git_branch_vkd3dproton}" # 7
  169. "${git_branch_dxvk}" # 8
  170. "${git_branch_glslang}" # 9
  171. "${git_branch_meson}" # 10
  172. "${git_branch_wine}" # 11
  173. )
  174. # Add git sources to argument list
  175. # Pass them to subscripts, as well.
  176. gitsources=(
  177. "${git_source_dxvknvapi}" # 12
  178. "${git_source_vkd3dproton}" # 13
  179. "${git_source_dxvk}" # 14
  180. "${git_source_glslang}" # 15
  181. "${git_source_meson}" # 16
  182. "${git_source_wine}" # 17
  183. "${git_source_winestaging}" # 18
  184. )
  185. #############################
  186. # Commit syntax validity check
  187. for githash in ${githash_overrides[@]}; do
  188. if [[ ! $(printf ${githash} | wc -c) -eq 40 ]] && \
  189. [[ ! ${githash} == HEAD ]]; then
  190. echo -e "\nError: badly formatted commit hash '${githash}' in the script file 'updatewine.sh'. Aborting\n"
  191. exit 1
  192. fi
  193. done
  194. ###########################################################
  195. params=(${datesuffix} ${githash_overrides[@]} ${gitbranch_overrides[@]} ${gitsources[@]} ${args[@]})
  196. ###########################################################
  197. # General function for question responses
  198. function questionresponse() {
  199. local response=${1}
  200. read -r -p "" response
  201. if [[ $(echo $response | sed 's/ //g') =~ ^([yY][eE][sS]|[yY])$ ]]; then
  202. echo ""
  203. return 0
  204. else
  205. return 1
  206. fi
  207. }
  208. ###########################################################
  209. function reqsCheck() {
  210. local AVAIL_SPACE
  211. local REC_SPACE
  212. local MSG_SPACE
  213. local AVAIL_RAM
  214. local REC_RAM
  215. local MSG_RAM
  216. AVAIL_SPACE=$(df -h -B MB --output=avail . | sed '1d; s/[A-Z]*//g')
  217. REC_SPACE=8000
  218. MSG_SPACE="\e[1mWARNING:\e[0m Not sufficient storage space\n\nYou will possibly run out of space while compiling software.\n\
  219. The script strongly recommends ~\e[1m$((${REC_SPACE} / 1000)) GB\e[0m at least to compile software successfully but you have only\n\
  220. \e[1m${AVAIL_SPACE} MB\e[0m left on the filesystem the script is currently placed at.\n\n\
  221. Be aware that the script process may fail because of this, especially while compiling Wine Staging.\n\n\
  222. Do you really want to continue? [Y/n]"
  223. AVAIL_RAM=$(( $(grep -oP "(?<=^MemFree:).*[0-9]" /proc/meminfo | sed 's/ //g') / 1024 ))
  224. REC_RAM=4096
  225. MSG_RAM="\e[1mWARNING:\e[0m Not sufficient RAM available\n\nCompilation processes will likely fail.\n\
  226. The script strongly recommends ~\e[1m${REC_RAM} MB\e[0m at least to compile software successfully but you have only\n\
  227. \e[1m${AVAIL_RAM} MB\e[0m left on the computer the script is currently placed at.\n\n\
  228. Be aware that the script process may fail because of this, especially while compiling DXVK.\n\n\
  229. Do you really want to continue? [Y/n]"
  230. function reqs_property() {
  231. local avail_prop
  232. local req_prop
  233. local req_message
  234. local req_installtargets
  235. local req_targetconditions
  236. local fullcondition
  237. local i
  238. avail_prop="${1}"
  239. req_prop="${2}"
  240. req_message="${3}"
  241. req_installtargets="${4}"
  242. i=0
  243. for req_installtarget in ${req_installtargets}; do
  244. req_targetconditions[$i]=$(echo "[[ ! -v ${req_installtarget} ]] ||")
  245. let i++
  246. done
  247. req_targetconditions=($(echo ${req_targetconditions[@]} | sed 's/\(.*\) ||/\1 /'))
  248. fullcondition="[[ "${avail_prop}" -lt "${req_prop}" ]] && ($(echo ${req_targetconditions[@]}))"
  249. if $(eval ${fullcondition}); then
  250. INFO_SEP
  251. echo -e "${req_message}"
  252. questionresponse
  253. if [[ $? -ne 0 ]]; then
  254. echo -e "Cancelling.\n"
  255. exit 1
  256. fi
  257. unset avail_prop req_prop req_installtarget req_targetconditions fullcondition
  258. fi
  259. }
  260. reqs_property "${AVAIL_SPACE}" "${REC_SPACE}" "${MSG_SPACE}" "NO_WINE"
  261. reqs_property "${AVAIL_RAM}" "${REC_RAM}" "${MSG_RAM}" "NO_DXVK"
  262. }
  263. ###########################################################
  264. function sudoQuestion() {
  265. sudo -k
  266. echo -e "\e[1mINFO:\e[0m sudo password required\n\nThis script requires elevated permissions for package updates & installations. Please provide your sudo password for these script commands. Sudo permissions are not used for any other purposes.\n"
  267. sudo -v
  268. if [[ $? -ne 0 ]]; then
  269. echo -e "Invalid sudo password.\n"
  270. exit 1
  271. fi
  272. # PID of the current main process
  273. PIDOF=$$
  274. # Run sudo timestamp update on the background and continue the script execution
  275. # Refresh sudo timestamp while the main process is running
  276. function sudo_refresh() {
  277. while [[ $(printf $(ps ax -o pid --no-headers | grep -o ${PIDOF} &> /dev/null)$?) -eq 0 ]]; do
  278. sudo -nv && sleep 2
  279. done
  280. }
  281. sudo_refresh &
  282. }
  283. ###########################################################
  284. function checkInternet() {
  285. if [[ $(echo $(wget --delete-after -q -T 5 github.com -o -)$?) -ne 0 ]]; then
  286. echo -e "\nDNS name resolution failed (GitHub). Please check your network connection settings and try again.\n"
  287. exit 1
  288. fi
  289. rm -f ./index.html.tmp
  290. }
  291. checkInternet
  292. ###########################################################
  293. # Only Debian & Arch based Linux distributions are currently supported
  294. function determineDistroFamily() {
  295. # These are default package managers used by the supported Linux distributions
  296. pkgmgrs=('dpkg' 'pacman')
  297. for pkgmgr in ${pkgmgrs[@]}; do
  298. if [[ $(printf $(which ${pkgmgr} &> /dev/null)$?) -eq 0 ]]; then
  299. pkgmgr_valid=${pkgmgr}
  300. fi
  301. done
  302. case ${pkgmgr_valid} in
  303. dpkg)
  304. distro="debian"
  305. ;;
  306. pacman)
  307. distro="arch"
  308. ;;
  309. default|*)
  310. echo -e "Your Linux distribution is not supported. Aborting.\n"
  311. exit 1
  312. ;;
  313. esac
  314. }
  315. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]] || [[ ! -v NO_VKD3D ]] || [[ ! -v NO_NVAPI ]]; then
  316. echo -e "\n${SCRIPT_TITLE}\n\nBuild identifier:\t${datesuffix}\n"
  317. else
  318. echo ""
  319. fi
  320. if [[ -n ${args[*]} ]]; then
  321. echo -e "Using arguments:\t${args[*]}\n"
  322. fi
  323. determineDistroFamily
  324. INFO_SEP
  325. echo -e "\e[1mNOTE: \e[0mDXVK requires very latest Nvidia/AMD drivers to work.\nMake sure these drivers are available on your Linux distribution.\n\
  326. This script comes with GPU driver installation scripts for Debian-based Linux distributions.\n"
  327. INFO_SEP
  328. if [[ ! -v NO_WINE ]] || [[ ! -v NO_DXVK ]] || [[ ! -v NO_VKD3D ]] || [[ ! -v NO_NVAPI ]]; then
  329. reqsCheck
  330. sudoQuestion
  331. echo ""
  332. fi
  333. bash -c "cd ${distro} && bash ./updatewine_${distro}.sh ${params[*]}"